'****************************************************************
'*  Name    : CanCfg.bas                                        *
'*  Author  : James S. McLaughlin                               *
'*  Notice  : Copyright (c) 2002                                *
'*          : All Rights Reserved                               *
'*  Date    : 3/7/2002                                          *
'*  Version : 1.0                                               *
'*  Notes   : can configuration (execute to setup can)          *
'*          :                                                   *
'****************************************************************

CanConfig:
    'see pages 204-206
    'CANCON= %10000000 & %11100000       'Request configuration mode
    CANCON.7 = 1             'Request configuration mode (looped on CANSTAT)
    configset:
    if CANSTAT.7 = 0 then goto configset   'wait until config mode active
    '10 kbs:
    BRGCON1 = %00100111     'brp = 39 (20 mhz), jump 1 TQ (SWJ)
    BRGCON2 = %10111111     'freely programmable (?), sample once, 8TQ seg1, 8TQ sel bits
    BRGCON3 = %00000111     '8TQ
    '125 kbs:
'    BRGCON1 = %00001001     'brp = 9 (20 mhz), jump 1 TQ (SWJ)
'    BRGCON2 = %10010000     'freely programmable (?), sample once, 3TQ seg1, 1TQ sel bits
'    BRGCON3 = %00000010     '3TQ
    '250 kbs (BRGCON1 only one that changes from 125 kbs):
'    BRGCON1 = %00000100     'brp = 4 (20 mhz), jump 1 TQ (SWJ)
'    BRGCON2 = %10010000     'freely programmable (?), sample once, 3TQ seg1, 1TQ sel bits
'    BRGCON3 = %00000010     '3TQ

    CIOCON = %01010000       'tx1 is TXD, message capture enabled
    'only question is whether CIOCON.5 (ENDRHI) is 1 (drive Vdd) or 0 (tri-state)
    
    'the use of separate declared vars is the result of developing this
    'code originally for a separate MCP2510 can controller, versus the
    '18PIC onboard device
    'This results in a lot of memory overhead.
    
    'masks and filters:
    'receive filter 0 mask and filters
    RXM0SIDH = RxMask0High
    RXM0SIDL = RxMask0Low

    RXF0SIDH = RxFilter0High
    RXF0SIDL = RxFilter0Low
    RXF1SIDH = RxFilter1High
    RXF1SIDL = RxFilter1Low

    'receive filter 1 mask and filters
    RXM1SIDH = RxMask1High
    RXM1SIDL = RxMask1Low
    
    RXF2SIDH = RxFilter2High
    RXF2SIDL = RxFilter2Low    
    RXF3SIDH = RxFilter3High
    RXF3SIDL = RxFilter3Low    
    RXF4SIDH = RxFilter4High
    RXF4SIDL = RxFilter4Low    
    RXF5SIDH = RxFilter5High
    RXF5SIDL = RxFilter5Low    
    
    'while we're at it, zero out the receive buffer dlc and data:
    RXB0DLC = 0
    RXB0D0 = 0
    RXB0D1 = 0
    RXB0D2 = 0
    RXB0D3 = 0
    RXB0D4 = 0
    RXB0D5 = 0
    RXB0D6 = 0
    RXB0D7 = 0

    RXB1DLC = 0
    RXB1D0 = 0
    RXB1D1 = 0
    RXB1D2 = 0
    RXB1D3 = 0
    RXB1D4 = 0
    RXB1D5 = 0
    RXB1D6 = 0
    RXB1D7 = 0

    'receive buffer control setup:
    'bit7 full status = 0 - ready to receive
    'bits6-5 mode, 0 = all valid messages, including extended id
    'bit4 na
    'bit3 remote tran 0 = no remote trans request
    'bit2 double buffer to receive buffer 1, 0 = no overflow allowed
    'bit1 jump table offset 0 = 1 and 0, read only copy of RX0DBEN (???)
    'bit0 filter set 0 = RXF0, 1 = RXF1
    RXB0CON = %00000000 

    'bits2-0 different for buffer 1, read only
    RXB1CON = %00000000 & %11100000
    
    CANCON.7 = 0            'set normal mode
    configset1:
    if CANSTAT.7 = 1 then goto configset1   'wait until normal mode active
    'CANCON.6 = 1             'set loopback mode and see what happens! (works!)
    'CANCON = %01100000 & %11100000      'listen only mode (Nothing!)
Return

